﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();

            // stop the timer, it should start after text has changed in the textbox
            timer1.Stop();

            // set the two labels to empty
            lblTimerUpdated.Text = "";
            lblHistoryUpdated.Text = "";
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            // prevent the timer from restarting (it will start when the text is changed in the textbox)
            timer1.Stop();
            lblTimerUpdated.Text = "Timer completed.";

            // add the text in the textbox to the history list
            TextHistory.Update(txtInput.Text);
        }

        private void btnHistory_Click(object sender, EventArgs e)
        {
            Form2 Form2 = new Form2();
            Form2.ListBoxIndexChanged += (s, ev) => { txtInput.Text = ev.ClickedText; };
            Form2.Show();
        }

        private void txtInput_TextChanged(object sender, EventArgs e)
        {
            timer1.Interval = 3000;
            timer1.Start();
            lblTimerUpdated.Text = "Timer started.";
        }

        private void txtInput_KeyDown(object sender, KeyEventArgs e)
        {
            // If enter is pressed clear the textbox, but update() the history first
            // in case the txtInput.Text is not there.

            if (e.KeyCode == Keys.Enter)
            {
                TextHistory.Update(txtInput.Text);
                txtInput.Text = "";
                timer1.Stop();
            }
        }
    }
}
