﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WindowsFormsApp1
{
    public partial class Form2 : Form
    {
        // the ListBoxIndexChanged event will be raised when the listbox index changes
        // ie. when the user clicks on a text item in the list.
        public event EventHandler<ListBoxIndexChangedEventArgs> ListBoxIndexChanged;

        public Form2()
        {
            InitializeComponent();

            // register in FormTracker that history form is now open.
            FormTracker.HistoryFormIsOpen = true;

            // set the history listbox's datasource to the history list
            lstbHistory.DataSource = TextHistory.HistoryList;
        }

        private void Form2_FormClosed(object sender, FormClosedEventArgs e)
        {
            // register in formTracker that history form is now closed.
            FormTracker.HistoryFormIsOpen = false;
        }

        private void lstbHistory_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (FormTracker.HistoryFormIsOpening)
            {
                FormTracker.HistoryFormIsOpening = false;
            }
            else
            {
                OnListBoxIndexChanged(new ListBoxIndexChangedEventArgs(lstbHistory.Text));
            }
            
            
        }

        // method to raise the ListBoxIndexChanged event (user clicked a new item in the list
        protected virtual void OnListBoxIndexChanged(ListBoxIndexChangedEventArgs e)
        {
            ListBoxIndexChanged?.Invoke(this, e);
        }
    }
}
